;DIAR1S.DO makes DIARY1.CO 08/27/2012
;by Robert H. Pigford.
;Includes TXCAL by Mo Budlong and
;FILNAM finder 08/17/2012 R H Pigford
;For M100/T102
;Given a filename (6 chrs) POKEd into
;the AltLCD memory by DIAR1A.BA,
;compare each filename in directory for
;a match. Then compare just 6th chr and
;keep highest saved back into same
;AltLCD locn as orig filename from
;where it will be PEEKed by DIAR1A.BA.
;
;		M100	T200
POPALL:	EQU	14EDH;	1604H
PRSNAM:	EQU	4C0BH;	5ACAH
FNDFIL:	EQU	20AFH;	2BCCH
BK2SK:	EQU	6C9CH;	83E2H
TXTENT:	EQU	5F71H;	7327H
FILOFF:	EQU	F6E7H;	EFD2H
STKTOP:	EQU	FB9DH;	F650H
FKCTRL:	EQU	F650H;	EF32H
LBENBL:	EQU	FAADH;	EF0AH
DIRBTM:	EQU 	63930;	62133
BLKMOV:	EQU	27611;	33558
ALTLCD:	EQU	64704;	63408
PGMORG:	EQU 	62700
PROGRM:	EQU	PGMORG+3
;F:	EQU 0
F:	EQU ALTLCD-PROGRM
;Note: If F is activated above, then
;assemble at the PGMORG address, but do
;not savem it there.  Instead, go to 
;MENU and look at the _ASM_.DO file.
;You will need the following addresses
;that you will later use when editing
;the DIARY1.BA programs that makes
;CALLs this code.
;F=2001, MOVIT=62921+2001=64922
;FILNAM=62713+2001=64714
;TXCAL=62921+2001=64856. 
;Go to BASIC and type CALL62700.  This
;executes the program that moves itself
;into ALTLCD.
;Then SAVEM"DIARY1",64704,64921,22423
;Note: 22423 is entry to MENU. So if
;you inadvertantly run DIARY1.CO, you
;will return to MENU without damage.

	ORG PGMORG
	JMP MOVIT
START:	LXI H,0
	DAD SP
	SHLD BEGIN+1+F
	JMP BEGIN+F
FILNAM: DB '______';FN poked here,read
COUNT:	DB 19; # possbl dir file slots
F_ATRB:	DS 2
TSTLTR:	DS 1 ;last letter used for test
FNDLTR:	DS 1
BEGIN:	LXI SP,0;jump here if errors
	LXI H,DIRBTM ;get 1st atr byte
	SHLD F_ATRB+F;1st byte of file
	;in RAM directory gets incr +11
	;after each filename tried
;
FIND:	LXI H,FILNAM+F
	XCHG;addr of FILMAN now in DE
	MVI C,5
	LHLD F_ATRB+F;1st chr in dir
	MOV A,M;get atrib byte
	CPI 192  ;is it a .DO file?
	JZ MATCH+F ;yes, it is a match
	JNZ NEXT_F+F ;incr the file
;
MATCH:	;test each chr in RAM directory
	;to match FILNAM chrs
	;HL holds adr of file type byte
	INX H
	INX H
	INX H;point 1st ltr in dir file

;tst 1st chr in FILNAM
;use DE for FILNAM chr pointer
LTR1_5:	LDAX D;get chr pointed to by DE
	MOV B,A;put it in B
	MOV A,M;get chr from HL (dir)
	CMP B
	JNZ NEXT_F+F;if not same, punt
	INX H;next chr in dir filemane
	INX D;point to next FILNAM chr
	DCR C ;the chr count
	JZ LTR+F;done 5 chrs, move on
	JMP LTR1_5+F;go back for more
;
;if here, first 5 chrs have matched so
;tst 6th chr
	;HL now points to 6th ltr in
	;dir filename
LTR:	MOV A,M ;get 6th chr into B
	STA FNDLTR+F;save as chr found 
	MOV B,A

LTR6:	LDA TSTLTR+F
	CMP B ;result= TSTLST - FNDATR
	      ;ltr held in B
	JZ SAVLTR+F;record the letter
	;found FNDLTR that matched
	LDA TSTLTR+F
	INR A ;go up to next test ltr
	STA TSTLTR+F
	CPI 91 ;past Z?
	JZ NEXT_F+F;done all 26 poss
	;ltrs for this file in dir
	;Run all ltrs thru test of 
	;for each dir filename
	JMP LTR6+F ;loop back again
;
NEXT_F:	LHLD F_ATRB+F ;file addr pointer
	MVI D,0  ;for later DAD
	MVI E,11 ;with HL
	DAD D; D holds 0, E holds 11
	SHLD F_ATRB+F ;point next file
		    ;atrib
;need to count down from 19 (files)
;so we know when to stop
	LDA COUNT+F
	DCR A
	STA COUNT+F
	JZ FINAL+F ;done all 19 files, 
	 ;goto PROGRAM EXIT
	;FILNAM should contain name of
	;highest version found
	MVI A,'A'
	STA TSTLTR+F ;start fresh ltrs
	JMP FIND+F;do another file
;
FINAL:	LDA FILNAM+F+5
	INR A
	STA FILNAM+F+5
	RET ;FINDFL program exit
;
;------- SUBRs --------
SAVLTR:	LDA FNDLTR+F;get lst ltr that =
	;TSTLTR	found in dir filename
	MOV C,A 
	LDA FILNAM+F+5;HI_LTR
	CMP C;result = HI_LTR - FNDLTR
	;is FNDLTR higher than
	;HI_LTR?
	JM SAVLT1+F ;if minus,is higher
	JMP NEXT_F+F
SAVLT1:	MOV A,C
	STA FILNAM+F+5;HI_LTR
	JMP NEXT_F+F
;
;TXTCAL by Mo Budlong from
;P100 Mag, Dec 1988
;for the T102 08/18/2012
;
TXCAL:	PUSH H	;save all regs on entry
	PUSH D	;in opposite order to
	PUSH B	;POPALL runtine
	PUSH PSW
	MOV A,M ;HL points to str len
		;in VAR table
	INX H	;move up to pointer to
		;string
	MOV E,M	;Grab pointer to string
	INX H	;into DE
	MOV D,M
	XCHG	;pointer to str in HL
	MOV E,A ;length into E
	CALL PRSNAM ;Fn to sys at F746
	CALL FNDFIL ;locate dir entry
		;for file at 63302 F746
	JZ POPALL ;quit if not found
	INX H	;move pointer to file
	;start
	MOV E,M	;start of file into DE
	INX H
	MOV D,M
SAVSTK:	LHLD STKTOP;save stack top
	PUSH H	;to the stack
	LXI H,0	;Offset to start of
	SHLD FILOFF;file to EDIT is 
		;saved here
NEWSTK:	DAD SP	;get stack pointer
	SHLD STKTOP;save @ stk top pntr
	PUSH D	;file start on stack 
		;for TEXT
	MVI A,1	;1= std EDIT,0= BASIC
		;EDIT
SETEXT:	LXI H,EXIT+F;Return from editor
	JMP TXTENT;Jump to editor
EXIT:	POP H  	;extra PUSH left by the
		;editor
	POP H	;Restore editor stack
	SHLD STKTOP
	CALL BK2SK;copy BASIC Fkey tbl
		;to SYS table
	XRA A	;turn off spec F-key
		;handling
	STA FKCTRL;spec Fkey byte
	DCR A	;Enable lbl keys with
		;FFH
	STA LBENBL;lbl line enable byte
	JMP POPALL;And exit, has RET
;end of TXCAL code by Mo Budlong
;
MOVIT:	LXI B,MOVIT-PROGRM;length
	LXI H,PROGRM ;source
	LXI D,PROGRM+F;destination
	CALL BLKMOV
	RET
END:	END
