;DIAR2S.DO makes DIARY2.CO 09/06/2012
;incl TXCAL2 adapted from Mo Budlong
;incl FINDFL  Aug. 2012 R H Pigford
;For M100/T200 per set of EQU values
;Given a filename (6 chrs) loaded into
;ALTLCD memory at FILNAM by DIAR2A.BA
;compare each filename directory for
;a match then compare just 6th chr,
;and keep highest filename to be PEEKed
;back by DIAR2A.BA
;
;		T200	M100
POPALL:	EQU	1604H;	14EDH
PRSNAM:	EQU	5ACAH;	4C0BH
FNDFIL:	EQU	2BCCH;	20AFH
BK2SK:	EQU	83E2H;	6C9CH
TXTENT:	EQU	7327H;	5F71H
FILOFF:	EQU	EFD2H;	F6E7H
STKTOP:	EQU	F650H;	FB9DH
FKCTRL:	EQU	EF32H;	F650H
LBENBL:	EQU	EF0AH;	FAADH
DIRBTM:	EQU 	62133;  63930
BLKMOV:	EQU	33558;	27611
ALTLCD:	EQU	63408;	64704
PGMORG:	EQU 	60000
PROGRM:	EQU	PGMORG+3
;F:	EQU 0;use for ASM testing
F:	EQU ALTLCD-PROGRM
;Note: If F is activated above, then
;assemble at the PGMORG address, but do
;not savem it there.  Instead, go to 
;MENU and look at the _ASM_.DO file.
;You will need the following addresses
;that you will later use when editing
;the DIARY.BA programs that CALLs this
;code.
;F= 3405, MOVIT=60221+3405=63626
;FILNAM=60013+3405=63418
;TXCAL2=60155+3405=63560 
;Go to BASIC and type CALL60000.  This
;executes the program that moves itself
;into ALTLCD.
;Then SAVEM"DIARY2",63408,63625,26532
;Note: 26532 is entry to MENU in case
;you inadvertantly run it from MENU,
;it will return to MENU without damage.


	ORG PGMORG
	JMP MOVIT
START:	LXI H,0
	DAD SP
	SHLD BEGIN+1+F
	JMP BEGIN+F
FILNAM: DB '______';FN poked here,read
COUNT:	DB 45; possible T200 dir slots
	     ; use 19 for M100/T102

F_ATRB:	DS 2
TSTLTR:	DS 1 ;last letter used for test
FNDLTR:	DS 1
BEGIN:	LXI SP,0;jump here if errors
	LXI H,DIRBTM ;get 1st atr byte
	SHLD F_ATRB+F;1st byte filename
	;in RAM directory gets incr +11
	;after each filename tried
;
FIND:	LXI H,FILNAM+F
	XCHG;addr of FILMAN now in DE
	MVI C,5
	LHLD F_ATRB+F;1st chr in dir
	MOV A,M;get atrib byte
	CPI 192  ;is it a .DO file?
	JZ MATCH+F ;yes, it is a match
	JNZ NEXT_F+F ;incr file slot
;
MATCH:	;test each chr in RAM directory
	;to match FILNAM chrs
	;HL holds adr of file type byte
	INX H
	INX H
	INX H;point 1st ltr in dir file

;tst 1st chr in FILNAM
;use DE for FILNAM chr pointer
LTR1_5:	LDAX D;get chr pointed to by DE
	MOV B,A;put it in B
	MOV A,M;get chr from HL (dir)
	CMP B
	JNZ NEXT_F+F;if not same, punt
	INX H;next chr in dir filename
	INX D;point to next FILNAM chr
	DCR C ;the chr count
	JZ LTR+F;done 5 chrs, move on
	JMP LTR1_5+F;go back for more
;
;if here, first 5 chrs have matched so
;tst 6th chr
	;HL now points to 6th ltr in
	;dir filename
LTR:	MOV A,M ;get 6th chr into B
	STA FNDLTR+F;save as chr found 
	MOV B,A

LTR6:	LDA TSTLTR+F
;	STA LSTLTR+F ;diagnostic record
	CMP B ;result= TSTLST - FNDATR
	      ;ltr held in B
	JZ SAVLTR+F;record the letter
	;found FNDLTR that matched
	LDA TSTLTR+F
	INR A ;go up to next test ltr
	STA TSTLTR+F
	CPI 91 ;past Z?
	JZ NEXT_F+F;done all 26 poss
	;ltrs for this file in dir
	;Run all ltrs thru test of 
	;for each dir filename
	JMP LTR6+F ;loop back again
;
NEXT_F:	LHLD F_ATRB+F;file addr pointer
	MVI D,0  ;for later DAD
	MVI E,11 ;with HL
	DAD D; D holds 0, E holds 11
	SHLD F_ATRB+F ;point next file
		      ;atrib
;Count down from 19 files M100, 45 T200
;so we know when all directory tested.
	LDA COUNT+F
	DCR A
	STA COUNT+F
	JZ FINAL+F ;done all files, 
	 ;goto PROGRAM EXIT
	;FILNAM should contain name of
	;highest version found
	MVI A,'A'
	STA TSTLTR+F ;start fresh ltrs
	JMP FIND+F;do another file
;
FINAL:	LDA FILNAM+F+5
	INR A
	STA FILNAM+F+5
	RET ;FINDFL program exit
;
;------- SUBRs --------
SAVLTR:	LDA FNDLTR+F;get lst ltr that =
	;TSTLTR	found in dir filename
	MOV C,A 
	LDA FILNAM+F+5;HI_LTR
	CMP C;result = HI_LTR - FNDLTR
	;is FNDLTR higher than
	;HI_LTR?
	JM SAVLT1+F ;if minus,is higher
	JMP NEXT_F+F
SAVLT1:	MOV A,C
	STA FILNAM+F+5;HI_LTR
	;call beep
	JMP NEXT_F+F
;
;TXCAL2 is TXCAL by Mo Budlong from
;P100 Mag, Dec 1988, adapted by RHP
;for the T200 08/18/2012
;
TXCAL2:	PUSH H	;save all regs on entry
	PUSH D	;in opposite order to
	PUSH B	;POPALL runtine
	PUSH PSW
	MOV A,M ;HL points to str len
		;in VAR table
	INX H	;move up to pointer to
		;string
	MOV E,M	;Grab pointer to string
	INX H	;into DE
	MOV D,M
	XCHG	;pointer to str in HL
	MOV E,A ;length into E
	CALL PRSNAM ;Fn to sys at F746
	CALL FNDFIL ;locate dir entry
		;for file at 63302 F746
	JZ POPALL ;quit if not found
	INX H	;move pointer to file
	;start
	MOV E,M	;start of file into DE
	INX H
	MOV D,M
SAVSTK:	LHLD STKTOP;save stack top
	PUSH H	;to the stack
	LXI H,0	;Offset to start of
	SHLD FILOFF;file to EDIT is 
		;saved here
NEWSTK:	DAD SP	;get stack pointer
	SHLD STKTOP;save @ stk top pntr
	PUSH D	;file start on stack 
		;for TEXT
	MVI A,1	;1= std EDIT,0= BASIC
		;EDIT
SETEXT:	LXI H,EXIT+F;Return from editor
	JMP TXTENT;Jump to editor
EXIT:	POP H  	;extra PUSH left by the
		;editor
	POP H	;Restore editor stack
	SHLD STKTOP
	CALL BK2SK;copy BASIC Fkey tbl
		;to SYS table
	XRA A	;turn off spec F-key
		;handling
	STA FKCTRL;spec Fkey byte
	DCR A	;Enable lbl keys with
		;FFH
	STA LBENBL;lbl line enable byte
	JMP POPALL;And exit, has RET
;
MOVIT:	LXI B,MOVIT-PROGRM;length
	LXI H,PROGRM ;source
	LXI D,PROGRM+F;destination
	CALL BLKMOV
	RET
END:	END
