DAIRY.BA Program Documentation
by Bob Pigford 2013

For Models M100/T102 and T200

Overview
---------
DIARY.BA is a BASIC program that automatically creates a date-related .DO filename and quickly moves the user into TEXT where he/she may write notes and comments.

When finished entering comments of the day, the user hits F8 and returns to MENU. The new 'D'iary file then appears on the MENU.  Multiple 'D'iary files can be created on the same day, as the successive filenames will be incremented.

As with all TEXT files, the 'D'iary file length is determined only by the free RAM constraints of the ModelT.

For archiving, the user needs to transfer these 'D'iary files to other storage media (NADSBox or other) using his/her favorite DOS program (ex: TS-DOS, TEENY, LaddieCon, Desklink, etc).

The 'D'iary filenames are "sortable" in filename (date) order on your PC, Mac, and probably LINUX computer.  Ten years of 'D'iary files can be created before a filename will be repeated.


User operation:
---------------
1. Run the appropriate version of DIARY.BA from the MENU using the widebar cursor and the Enter key as you would any other .BA program.

2. The first screen displays the currently set date and time of your ModelT and asks if these are correct (Y/N).

3. If the date and time are not as you want them, choose (N) and you will be back in BASIC where you may reset date/time using DATE$ and TIME$.  Press F4 to re-run the program, or press F8 to go to the MENU and re-run it from there.

4. If the date and time are correct, choose (Y).  Then the program loads 218 bytes into the AltLCD memory area where they will be subsequently used by DIARY.BA.  After about 5 seconds to collect your thoughts, you are transferred automatically into TEXT where you can then hit the down arrow to put the cursor on a new line then start writing.  All usual TEXT function keys work, including F8 to exit back to MENU.

Other programs that use the AltLCD memory area can over-write this memory area without damage to DIARxA.BA, because each running of DIARxA.BA reloads its needed bytes into the AltLCD memory area.


DIARY.BA versions:
------------------
DIAR1A.BA for the M100/T102
DIAR2A.BA for the T200

When downloading, be careful to choose the right version for your ModelT.  Do not mix them up as a ModelT crash could occur requiring a RESET or a Cold Start.

Giving credit where it is due:
------------------------------
The idea, the BASIC code, and a large part of the assembly code for this program are mine, but I had some valuable help with parts.

Most importantly, the code segment that makes the jump to TEXT and back to BASIC was written by the late Mo Budlong and published in "Portable 100 Magazine", Dec. 1988.  Mo provided this "jump" code for the M100, and I researched and created the M200 equivalent.

Ken Pettit generously helped me find an error in my assembly code.

Special thanks to Mike Stein for helping me simplify the code in my BASIC program that creates the date-related filename.

I am especially grateful to the late Paul Globman for teaching me how to use the ROM2 OptROM to assemble a source file so it will execute in the AltLCD memory area (this technique is noted in each of the asm source files listed below).


6 character 'D' filename positions:
-----------------------------------
1. Always = D to denote a DIARY file.

2. Year = 0 thru 9 for the last digit of the calendar year (ex: 2013 would be 3).

3. Month = 1 though C. (ex: Jan = 1, Sept = 9, October = A, November = B, December = C)

4 and 5. = the day of the month (2 digits).  (ex: the 5th = 05, the 30th = 30)

6. The file letter when more than one 'D' file is created on the same day.  First file of the day is receives an A. Subsequent files that day will be shown as B, C, D, etc.  Single day creation of more than 26 'D' files may cause unpredictable results.

Note: The last, highest filename found on the MENU for the current day is always used when DIARxA.BA creates the next 'D' file.  So, even if you have archived earlier files from that day, if you leave your last one on the MENU then start another, DIARxA.BA will create the next relative incremental file.  This helps avoid accidental overwriting the same earlier filenames when you archive them.


Other files for info:
---------------------
DIARDO.DO  = this overview and directions for operation.

DIAR1A.DO = TEXT listing of DIAR1A.BA
DIAR2A.DO = TEXT listing of DIAR2A.BA

DIAR1S.DO = M100 Assembly TEXT listing
DIAR2S.DO = T200 Assembly TEXT listing

GTDAT1.DO = TEXT listing of another BASIC program I wrote for use after ROM2 Assembly. This program was used to retrieve the byte values from the AltLCD memory and put them into a DATA1.DO file as DATA statements for subsequent MERGE'ing to finish creating DIAR1A.BA.

GTDAT2.DO = Same as above for the T200.


Additional note on PC sorting 'D' files:
----------------------------------------
Filename (date) ordered sorting of 'D' files within a directory on the PC works well using Total Commander or Win2K.  WinXP and later Win OS versions use a different interpretation of numbers within filenames.  There is a registry tweak to change back to the earlier sort order. Google may be helpful here.


Minimizing DIARxA.BA file size:
-------------------------------
You can reduce the size of DIARxA.BA by removing comment lines and combining some lines.  The Cleuseau part of the ROM2/Cleuseau Option ROM is good for this.  However, the code in line number 230 should remain as an individual line.  I found that adding any more code to the end of that line can make the program fail to return to the MENU after pressing F8.  I could not figure out why.


Summary:
--------
I hope you actually use this little program to improve your time effectiveness and help you find another reason to keep using your terrific ModelTs.

Bob Pigford
Newark, DE USA
bob at pigford dot org
March 2013